Bug 1906697 - ceph fails to build: error: no type named 'type' in 'struct std::enable_if<false, std::basic_ostream<char>&>'
Summary: ceph fails to build: error: no type named 'type' in 'struct std::enable_if<fa...
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: ceph
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Kaleb KEITHLEY
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: F34FTBFS PYTHON3.10
TreeView+ depends on / blocked
 
Reported: 2020-12-11 07:52 UTC by Tomáš Hrnčiar
Modified: 2021-01-13 22:21 UTC (History)
14 users (show)

Fixed In Version: ceph-15.2.8-1.fc34
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-01-05 11:44:50 UTC
Type: Bug


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
GNU Compiler Collection 98231 0 P1 RESOLVED [11 Regression] bogus error: no match for ‘operator<<’ 2021-01-18 09:37:41 UTC

Description Tomáš Hrnčiar 2020-12-11 07:52:44 UTC
ceph fails to build with Python 3.10.0a3.

/usr/include/c++/11/ostream:773:5: error: no type named 'type' in 'struct std::enable_if<false, std::basic_ostream<char>&>'
...
gmake[2]: Leaving directory '/builddir/build/BUILD/ceph-15.2.7/build/x86_64-redhat-linux-gnu'
[ 83%] Built target unittest_rbd_mirror
gmake[1]: Leaving directory '/builddir/build/BUILD/ceph-15.2.7/build/x86_64-redhat-linux-gnu'
gmake: *** [Makefile:163: all] Error 2

For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.10/fedora-rawhide-x86_64/01823946-ceph/

For all our attempts to build ceph with Python 3.10, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/package/ceph/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.10:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/

Let us know here if you have any questions.

Python 3.10 will be included in Fedora 35. To make that update smoother, we're building Fedora packages with early pre-releases of Python 3.10.
A build failure prevents us from testing all dependent packages (transitive [Build]Requires), so if this package is required a lot, it's important for us to get it fixed soon.
We'd appreciate help from the people who know this package best, but if you don't want to work on this now, let us know so we can try to work around it on our side.

Comment 1 Miro Hrončok 2020-12-11 14:12:01 UTC
This is not limited to Python 3.10: https://koschei.fedoraproject.org/package/ceph?collection=f34

Comment 2 Marek Polacek 2020-12-15 20:05:51 UTC
This is a GCC 11 bug: https://gcc.gnu.org/PR98231.  Please wait a little bit; we'll sort it out in GCC upstream.

Comment 3 Kaleb KEITHLEY 2021-01-05 11:44:50 UTC
fixed (work-around pending gcc-11 bugfix) in ceph-15.2.8-1.fc34

Comment 4 Marek Polacek 2021-01-13 22:21:18 UTC
I just pushed a fix for the GCC bug.  It should make its way downstream before long, and you should be able to remove the workaround then.


Note You need to log in before you can comment on or make changes to this bug.